package worker;

import java.util.List;
import java.util.Random;
import java.util.concurrent.CancellationException;
import java.util.concurrent.ExecutionException;
import javax.swing.JTextField;
import javax.swing.SwingWorker;

public class CarloWorker extends SwingWorker<CarloPacket, CarloPacket> {
	public static int workercounter = 0;
	private Long cycles;
	private Double result;
	private int id;
	public JTextField cyclfield;
	CarloUI parent;
	boolean machmalschluss;
	long inputv;
	Random randinst;
	
	public CarloWorker(CarloUI father) {
		this.cyclfield = father.cycles;
		this.parent = father;
		machmalschluss = false;
		workercounter++;
		this.id=workercounter-1;
		randinst = new Random();
		result = 0D;
		cycles = 0L;
		
	}
	@Override
	public CarloPacket doInBackground() {
		//System.out.print(id+" macht gerade was im background\n");
		CarloPacket cp = null;
		while ((!isCancelled() && !machmalschluss)) {
		cycles++;			
		if (parent.randtype == 0) {inputv = cycles/1000;}
		else if (parent.randtype == 1) {inputv = (long)randinst.nextFloat()*100+900;}
		else {inputv = (long)Math.random()*100+900;}
		result = Math.log(Math.sqrt(Math.log(Math.sqrt(Math.log(Math.sqrt(inputv))))));
		if (cycles % 100000 == 0) {
		 cp = new CarloPacket(cycles, result, id);
		 publish(cp);
		}
		}
		cp = new CarloPacket(cycles, result, id);
		//System.out.print("Schon tot? "+ this.isCancelled()+" "+this.isDone()+"\n");
		return cp;
	}
	@Override
	protected void process(List<CarloPacket> packetliste) {
		CarloPacket cp = packetliste.get(packetliste.size() - 1);
		//System.out.print("Paket von Nr. "+cp.id+" angekommen mit "+cp.cycles+" Zyklen\n");
		if (this.getState()!=SwingWorker.StateValue.DONE) {parent.updateResults(cp);
		} else {System.out.print("Letzes Paket gecancelled!\n");}		
	}
	protected void aufhoeren(boolean sollich) {
		machmalschluss = sollich;
	}
	
	
	@Override
	protected void done() {
		CarloPacket endpack = null;
		try {
		endpack = get(); } 
		catch (InterruptedException ie) {System.err.print("InterruptedException\n");} 
		catch (ExecutionException ee){System.err.print("ExecutionException\n");}
		catch (CancellationException ce) {System.err.print("CancellationException\n");}
		//System.out.print("Ende für "+endpack+" im Dispatchthread? "+SwingUtilities.isEventDispatchThread()+"\n");		
		parent.bringFinalResults(endpack);

	}
}
